﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.ListControls;
using Infragistics.Web.UI;
using Infragistics.Web.UI.GridControls;


public partial class TestCmbDepGridPage : System.Web.UI.Page
{

    protected void cmb2_Init(object sender, EventArgs e)
    {  
        WebDropDown cmbEstado = (WebDropDown)sender;
        cmbEstado.TextField = "EstadoDesc";
        cmbEstado.ValueField = "EstadoID";
        cmbEstado.DataSource = LoadComboEstado(0);
        cmbEstado.DataBind();    
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        this.WebDataGrid1.DataSource = LoadRecords();       
    }  

    protected void eProvider_ItemsRequested(object sender, DropDownItemsRequestedEventArgs e)
    {
        int paisID = -1;
        DataTable dtPais;
        WebDropDown cmbEstado = (WebDropDown)sender;

        cmbEstado.Items.Clear();
        dtPais = (DataTable)Session["PaisCmbSource"];

        DataRow[] rows = dtPais.Select("PaisDesc='" + e.Value.ToString() + "'");
        paisID = (int)rows[0]["PaisID"];

       // cmbEstado.CurrentValue = "";
        cmbEstado.TextField = "EstadoDesc";
        cmbEstado.ValueField = "EstadoID";
        cmbEstado.DataSource = LoadComboEstado(paisID);    
        cmbEstado.DataBind();
    }

    private DataTable LoadRecords()
    {
        DataTable dt = new DataTable();
        dt.Columns.Add("ID", typeof(int));
        dt.Columns.Add("Pais", typeof(int));
        dt.Columns.Add("Estado", typeof(int));

        dt.Rows.Add(1, 1, 1);
        dt.Rows.Add(2, 2, 3);

        DataColumn[] pk = new DataColumn[1];
        pk[0] = dt.Columns["ID"];
        dt.PrimaryKey = pk;

        return dt;
    }

    protected void WebDataGrid1_DataBound(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            Session.Add("PaisCmbSource", LoadComboPais());
        }

        WebDropDown cmb = (WebDropDown)this.WebDataGrid1.EditorProviders["WebDataGrid1_DropDownProvider1"].GetEditor();
        cmb.TextField = "PaisDesc";
        cmb.ValueField = "PaisID";
        cmb.DataSource = Session["PaisCmbSource"];
        cmb.DataBind();
    }

    private DataTable LoadComboPais()
    {
        DataTable dt = new DataTable("Pais");
        dt.Columns.Add("PaisID", typeof(int));
        dt.Columns.Add("PaisDesc", typeof(string));

        dt.Rows.Add(1, "Mexico");
        dt.Rows.Add(2, "USA");

        return dt;
    }

    private DataTable LoadComboEstado(int paisID)
    {
        DataTable dt = new DataTable("Estado");
        dt.Columns.Add("EstadoID", typeof(int));
        dt.Columns.Add("EstadoDesc", typeof(string));

        if (paisID == 1)
        {
            dt.Rows.Add(1, "NL");
            dt.Rows.Add(2, "BC");
        }
        else if (paisID == 2)
        {
            dt.Rows.Add(3, "CA");
            dt.Rows.Add(4, "TX");
        }
        else
        {
            dt.Rows.Add(1, "NL");
            dt.Rows.Add(2, "BC");
            dt.Rows.Add(3, "CA");
            dt.Rows.Add(4, "TX");
        }

        return dt;
    }
}
